#include QMK_KEYBOARD_H
#include "keymap_french.h"

#define _QWERTY 0
#define _LOWER 1
#define _SHEET 2
#define _ADJUST 3

enum custom_keycodes {
  QWERTY = SAFE_RANGE,
  LOWER,
  SHEET,
  ADJUST,
};

const uint16_t PROGMEM keymaps[][MATRIX_ROWS][MATRIX_COLS] = {

  [_QWERTY] = LAYOUT(
  //┌────────┬────────┬────────┬────────┬────────┬────────┐                          ┌────────┬────────┬────────┬────────┬────────┬────────┐
     _______, _______, _______, _______, _______, _______,                            _______, _______, _______, _______, _______, _______,
  //├────────┼────────┼────────┼────────┼────────┼────────┤                          ├────────┼────────┼────────┼────────┼────────┼────────┤
    FR_CIRC,  KC_Q,    KC_W,    KC_E,    KC_R,    KC_T,                               KC_Y,    KC_U,    KC_I,    KC_O,    KC_P,   FR_DLR,
  //├────────┼────────┼────────┼────────┼────────┼────────┤                          ├────────┼────────┼────────┼────────┼────────┼────────┤
FR_ASTR, LGUI_T(KC_A),RALT_T(KC_S),CTL_T(KC_D),LSFT_T(KC_F),KC_G,                  KC_H,RSFT_T(KC_J),CTL_T(KC_K), RALT_T(KC_L), RGUI_T(KC_SCLN), FR_UGRV,
  //├────────┼────────┼────────┼────────┼────────┼────────┼────────┐        ┌────────┼────────┼────────┼────────┼────────┼────────┼────────┤
    FR_LABK, KC_Z,    KC_X,    KC_C,    KC_V,    KC_B, _______,              _______,  KC_N,    KC_M,    KC_COMM, KC_DOT, KC_SLSH, FR_EQL,
  //└────────┴────────┴────────┴───┬────┴───┬────┴───┬────┴───┬────┘        └───┬────┴───┬────┴───┬────┴───┬────┴────────┴────────┴────────┘
                                  LT(_LOWER, KC_TAB), KC_ENT,  KC_ESC,         KC_BSPC,  KC_SPC,LT(_ADJUST, KC_TAB)
                                // └────────┴────────┴────────┘                 └────────┴────────┴────────┘
  ),


  [_LOWER] = LAYOUT(
  //┌────────┬────────┬────────┬────────┬────────┬────────┐                          ┌────────┬────────┬────────┬────────┬────────┬────────┐
     _______, _______, _______, _______, _______, _______,                            _______, _______, _______, _______, _______, _______,
  //├────────┼────────┼────────┼────────┼────────┼────────┤                          ├────────┼────────┼────────┼────────┼────────┼────────┤
     _______, _______, KC_MUTE, KC_VOLD, KC_VOLU , _______,                            KC_6,   KC_7,     KC_8,   KC_9 , KC_0, KC_MINS,
  //├────────┼────────┼────────┼────────┼────────┼────────┤                          ├────────┼────────┼────────┼────────┼────────┼────────┤
      _______, KC_LGUI,     KC_LALT,   KC_LCTL, KC_LSFT, _______,                       KC_LEFT, KC_DOWN, KC_UP,   KC_RGHT, _______, _______,
  //├────────┼────────┼────────┼────────┼────────┼────────┼────────┐        ┌────────┼────────┼────────┼────────┼────────┼────────┼────────┤
     _______, _______, _______, _______, _______, _______, _______,          _______,   KC_F7,   KC_F8,    KC_F9, KC_F10  , KC_F11, KC_F12, 
  //└────────┴────────┴────────┴───┬────┴───┬────┴───┬────┴───┬────┘        └───┬────┴───┬────┴───┬────┴───┬────┴────────┴────────┴────────┘
                                    _______, _______, _______,                   KC_DEL, _______, TO(_SHEET)
                                // └────────┴────────┴────────┘                 └────────┴────────┴────────┘
  ),


  [_ADJUST] = LAYOUT(
  //┌────────┬────────┬────────┬────────┬────────┬────────┐                          ┌────────┬────────┬────────┬────────┬────────┬────────┐
     _______, _______, _______, _______, _______, _______,                            _______, _______, _______, _______, _______, _______,
  //├────────┼────────┼────────┼────────┼────────┼────────┤                          ├────────┼────────┼────────┼────────┼────────┼────────┤
     KC_GRV,  KC_1,    KC_2,    KC_3,    KC_4,    KC_5,                             KC_MS_LEFT, KC_MS_DOWN, KC_MS_UP, KC_MS_RIGHT, KC_MS_BTN1 , KC_MS_BTN2,
  //├────────┼────────┼────────┼────────┼────────┼────────┤                          ├────────┼────────┼────────┼────────┼────────┼────────┤
     _______, FR_BSLS, FR_LCBR, FR_LBRC, FR_RBRC, FR_RCBR,                         _______,  KC_RSFT,   KC_RCTL, KC_RALT, KC_RGUI, _______ ,
  //├────────┼────────┼────────┼────────┼────────┼────────┼────────┐        ┌────────┼────────┼────────┼────────┼────────┼────────┼────────┤
     KC_F1,   KC_F2,   KC_F3,   KC_F4,   KC_F5,   KC_F6,   _______,         _______, _______, _______, _______, _______, _______, _______,
  //└────────┴────────┴────────┴───┬────┴───┬────┴───┬────┴───┬────┘        └───┬────┴───┬────┴───┬────┴───┬────┴────────┴────────┴────────┘
                                    TO(_SHEET), _______, _______,                   _______, _______, _______
                                // └────────┴────────┴────────┘                 └────────┴────────┴────────┘
  ),

  [_SHEET] = LAYOUT(
  //┌────────┬────────┬────────┬────────┬────────┬────────┐                          ┌────────┬────────┬────────┬────────┬────────┬────────┐
     _______, _______, _______, _______, _______, _______,                            _______, _______, _______, _______, _______, _______,
  //├────────┼────────┼────────┼────────┼────────┼────────┤                          ├────────┼────────┼────────┼────────┼────────┼────────┤
     KC_TAB, XXXXXXX, KC_P7,    KC_P8,   KC_P9,   KC_PSLS,                            XXXXXXX, XXXXXXX, XXXXXXX, XXXXXXX, XXXXXXX, KC_SLEP,
  //├────────┼────────┼────────┼────────┼────────┼────────┤                          ├────────┼────────┼────────┼────────┼────────┼────────┤
     KC_DEL, XXXXXXX, KC_P4,    KC_P5,   KC_P6,   KC_PAST,                            KC_LEFT, KC_DOWN, KC_UP,   KC_RGHT, XXXXXXX, XXXXXXX,
  //├────────┼────────┼────────┼────────┼────────┼────────┼────────┐        ┌────────┼────────┼────────┼────────┼────────┼────────┼────────┤
    _______, XXXXXXX, KC_P1,    KC_P2,   KC_P3,   KC_PMNS, _______,         _______, XXXXXXX, XXXXXXX, XXXXXXX,  XXXXXXX, XXXXXXX, XXXXXXX,
  //└────────┴────────┴────────┴───┬────┴───┬────┴───┬────┴───┬────┘        └───┬────┴───┬────┴───┬────┴───┬────┴────────┴────────┴────────┘
                                    KC_P0,   KC_ENT, KC_BSPC,                   _______, _______, TO(_QWERTY)
                                // └────────┴────────┴────────┘                 └────────┴────────┴────────┘
  )

};

bool process_record_user(uint16_t keycode, keyrecord_t *record) {
  switch (keycode) {
    case QWERTY:
      if (record->event.pressed) {
        set_single_persistent_default_layer(_QWERTY);
      }
      return false;
      break;
    case LOWER:
      if (record->event.pressed) {
        layer_on(_LOWER);
        update_tri_layer(_LOWER, _SHEET, _ADJUST);
      } else {
        layer_off(_LOWER);
        update_tri_layer(_LOWER, _SHEET, _ADJUST);
      }
      return false;
      break;
    case SHEET:
      if (record->event.pressed) {
        layer_on(_SHEET);
        update_tri_layer(_LOWER, _SHEET, _ADJUST);
      } else {
        layer_off(_SHEET);
        update_tri_layer(_LOWER, _SHEET, _ADJUST);
      }
      return false;
      break;
    case ADJUST:
      if (record->event.pressed) {
        layer_on(_ADJUST);
      } else {
        layer_off(_ADJUST);
      }
      return false;
      break;
  }
  return true;
}

void matrix_scan_user(void) {
  static bool has_run;
  if (!has_run) {
    has_run = true;
        rgblight_disable();
  }
}

layer_state_t layer_state_set_user(layer_state_t state) {
    switch (biton32(state)) {
    case _SHEET:
        rgblight_enable();
        rgblight_sethsv_noeeprom(HSV_WHITE);
        break;
    default: //  for any other layers, or the default layer
        rgblight_disable();
        break;
    }
  return state;
}

